diff --git a/common/src/main/scala/net/psforever/packet/game/objectcreate/CharacterAppearanceData.scala b/common/src/main/scala/net/psforever/packet/game/objectcreate/CharacterAppearanceData.scala
index c2b064d3..c3f17921 100644
--- a/common/src/main/scala/net/psforever/packet/game/objectcreate/CharacterAppearanceData.scala
+++ b/common/src/main/scala/net/psforever/packet/game/objectcreate/CharacterAppearanceData.scala
@@ -23,12 +23,13 @@ import shapeless.{::, HNil}
   *                  -player_guid - does nothing?
   * @param exosuit   the type of exo-suit the avatar will be depicted in;
   *                  for Black OPs, the agile exo-suit and the reinforced exo-suit are replaced with the Black OPs exo-suits
+  * @param char_id   a unique character reference identification number
   */
 final case class CharacterAppearanceA(app : BasicCharacterData,
                                       data : CommonFieldData,
                                       exosuit : ExoSuitType.Value,
                                       unk5 : Int,
-                                      unk6 : Long,
+                                      char_id : Long,
                                       unk7 : Int,
                                       unk8 : Int,
                                       unk9 : Int,
diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index f7b96aa0..245c3a29 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -121,6 +121,7 @@ class SquadService extends Actor {
               //other players were in the squad; publicly disband it
               squad.Membership.foreach(position => {
                 position.Name = ""
+                position.CharId = 0L
                 position.ZoneId = 0
                 position.Position = Vector3.Zero
                 position.Health = 0
@@ -151,6 +152,8 @@ class SquadService extends Actor {
       import net.psforever.packet.game.SquadAction._
       val squadOpt = GetParticipatingSquad(tplayer, zone_ordinal_number)
       action match {
+        case SaveSquadDefinition() =>
+
         case ChangeSquadPurpose(purpose) =>
           log.info(s"${tplayer.Name}-${tplayer.Faction} has changed his squad's task to $purpose")
           val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
@@ -265,6 +268,7 @@ class SquadService extends Actor {
                   val hadPreviousPosition = squad.Membership.find(_.Name == name) match {
                     case Some(currentPosition)=>
                       currentPosition.Name = ""
+                      currentPosition.CharId = 0L
                       currentPosition.ZoneId = 0
                       currentPosition.Health = 0
                       currentPosition.Armor = 0
@@ -274,6 +278,7 @@ class SquadService extends Actor {
                       false
                   }
                   desiredPosition.Name = name
+                  desiredPosition.CharId = tplayer.CharId
                   desiredPosition.ZoneId = zone_ordinal_number
                   desiredPosition.Health = tplayer.Health
                   desiredPosition.Armor = tplayer.Armor
@@ -380,7 +385,7 @@ class SquadService extends Actor {
       PlanetSideZoneID(squad.ZoneId),
       squad.Membership.zipWithIndex.map({ case (p, index) =>
         if(squad.Availability(index)) {
-          SquadPositionDetail(p.Role, p.Orders, p.Requirements, p.Name)
+          SquadPositionDetail(p.Role, p.Orders, p.Requirements, p.CharId, p.Name)
         }
         else {
           SquadPositionDetail.Closed
diff --git a/common/src/test/scala/game/SquadDetailDefinitionUpdateMessageTest.scala b/common/src/test/scala/game/SquadDetailDefinitionUpdateMessageTest.scala
index 5ad56bd0..cf56fb86 100644
--- a/common/src/test/scala/game/SquadDetailDefinitionUpdateMessageTest.scala
+++ b/common/src/test/scala/game/SquadDetailDefinitionUpdateMessageTest.scala
@@ -12,7 +12,7 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
   "SquadDetailDefinitionUpdateMessage" should {
     "decode" in {
       PacketCoding.DecodePacket(string).require match {
-        case SquadDetailDefinitionUpdateMessage(guid, unk, leader, task, zone, member_info) =>
+        case SquadDetailDefinitionUpdateMessage(guid, unk1, char_id, unk2, leader, task, zone, member_info) =>
           ok
         case _ =>
           ko
@@ -22,24 +22,25 @@ class SquadDetailDefinitionUpdateMessageTest extends Specification {
     "encode" in {
       val msg = SquadDetailDefinitionUpdateMessage(
         PlanetSideGUID(3),
+        42771010L,
         "HofD",
         "\\#ffdc00***\\#9640ff=KOK+SPC+FLY=\\#ffdc00***\\#FF4040 All Welcome",
         PlanetSideZoneID(7),
         List(
-          SquadPositionDetail("\\#ff0000 |||||||||||||||||||||||", ""),
+          SquadPositionDetail("\\#ff0000 |||||||||||||||||||||||", "Just a space filler"),
           SquadPositionDetail("\\#ffdc00   C", ""),
-          SquadPositionDetail("\\#ffdc00   H", "", "OpoIE"),
-          SquadPositionDetail("\\#ffdc00    I", "", "BobaF3tt907"),
+          SquadPositionDetail("\\#ffdc00   H", "", Set(), 42644970L, "OpoIE"),
+          SquadPositionDetail("\\#ffdc00    I", "", Set(), 41604210L, "BobaF3tt907"),
           SquadPositionDetail("\\#ffdc00   N", ""),
           SquadPositionDetail("\\#ffdc00   A", ""),
-          SquadPositionDetail("\\#ff0000 |||||||||||||||||||||||", ""),
+          SquadPositionDetail("\\#ff0000 |||||||||||||||||||||||", "Another space filler"),
           SquadPositionDetail("\\#9640ff   K", ""),
-          SquadPositionDetail("\\#9640ff   O", "", "HofD"),
+          SquadPositionDetail("\\#9640ff   O", "", Set(), 42771010L, "HofD"),
           SquadPositionDetail("\\#9640ff   K", "")
         )
       )
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
-      ok
+      pkt mustEqual string
     }
   }
 }
diff --git a/common/src/test/scala/game/objectcreate/CharacterDataTest.scala b/common/src/test/scala/game/objectcreate/CharacterDataTest.scala
index eece5121..22a1e7db 100644
--- a/common/src/test/scala/game/objectcreate/CharacterDataTest.scala
+++ b/common/src/test/scala/game/objectcreate/CharacterDataTest.scala
@@ -48,7 +48,7 @@ class CharacterDataTest extends Specification {
                   a.data.v5.isEmpty mustEqual true
                   a.exosuit mustEqual ExoSuitType.Reinforced
                   a.unk5 mustEqual 0
-                  a.unk6 mustEqual 30777081L
+                  a.char_id mustEqual 30777081L
                   a.unk7 mustEqual 1
                   a.unk8 mustEqual 4
                   a.unk9 mustEqual 0
@@ -167,7 +167,7 @@ class CharacterDataTest extends Specification {
                   a.data.v5.isEmpty mustEqual true
                   a.exosuit mustEqual ExoSuitType.Reinforced
                   a.unk5 mustEqual 0
-                  a.unk6 mustEqual 192L
+                  a.char_id mustEqual 192L
                   a.unk7 mustEqual 0
                   a.unk8 mustEqual 0
                   a.unk9 mustEqual 0
@@ -236,7 +236,7 @@ class CharacterDataTest extends Specification {
                   a.data.v5.isEmpty mustEqual true
                   a.exosuit mustEqual ExoSuitType.MAX
                   a.unk5 mustEqual 1
-                  a.unk6 mustEqual 0L
+                  a.char_id mustEqual 0L
                   a.unk7 mustEqual 0
                   a.unk8 mustEqual 0
                   a.unk9 mustEqual 0
diff --git a/common/src/test/scala/game/objectcreatedetailed/DetailedCharacterDataTest.scala b/common/src/test/scala/game/objectcreatedetailed/DetailedCharacterDataTest.scala
index e64dd8fc..34175c27 100644
--- a/common/src/test/scala/game/objectcreatedetailed/DetailedCharacterDataTest.scala
+++ b/common/src/test/scala/game/objectcreatedetailed/DetailedCharacterDataTest.scala
@@ -76,7 +76,7 @@ class DetailedCharacterDataTest extends Specification {
                   a.data.v5.isEmpty mustEqual true
                   a.exosuit mustEqual ExoSuitType.Standard
                   a.unk5 mustEqual 0
-                  a.unk6 mustEqual 41605313L
+                  a.char_id mustEqual 41605313L
                   a.unk7 mustEqual 0
                   a.unk8 mustEqual 0
                   a.unk9 mustEqual 0
@@ -264,7 +264,7 @@ class DetailedCharacterDataTest extends Specification {
                   a.data.v5.isEmpty mustEqual true
                   a.exosuit mustEqual ExoSuitType.Standard
                   a.unk5 mustEqual 0
-                  a.unk6 mustEqual 192L
+                  a.char_id mustEqual 192L
                   a.unk7 mustEqual 0
                   a.unk8 mustEqual 0
                   a.unk9 mustEqual 0
@@ -449,7 +449,7 @@ class DetailedCharacterDataTest extends Specification {
                   a.data.v5.isEmpty mustEqual true
                   a.exosuit mustEqual ExoSuitType.MAX
                   a.unk5 mustEqual 1
-                  a.unk6 mustEqual 41605870L
+                  a.char_id mustEqual 41605870L
                   a.unk7 mustEqual 0
                   a.unk8 mustEqual 0
                   a.unk9 mustEqual 0
@@ -657,7 +657,7 @@ class DetailedCharacterDataTest extends Specification {
                   a.data.v5.isEmpty mustEqual true
                   a.exosuit mustEqual ExoSuitType.Agile
                   a.unk5 mustEqual 0
-                  a.unk6 mustEqual 733931L
+                  a.char_id mustEqual 733931L
                   a.unk7 mustEqual 0
                   a.unk8 mustEqual 0
                   a.unk9 mustEqual 0
@@ -1165,7 +1165,7 @@ class DetailedCharacterDataTest extends Specification {
                   a.data.v5.isEmpty mustEqual true
                   a.exosuit mustEqual ExoSuitType.Standard
                   a.unk5 mustEqual 0
-                  a.unk6 mustEqual 1176612L
+                  a.char_id mustEqual 1176612L
                   a.unk7 mustEqual 15
                   a.unk8 mustEqual 5
                   a.unk9 mustEqual 10
diff --git a/common/src/test/scala/game/objectcreatevehicle/MountedVehiclesTest.scala b/common/src/test/scala/game/objectcreatevehicle/MountedVehiclesTest.scala
index 5b73667f..1c831f74 100644
--- a/common/src/test/scala/game/objectcreatevehicle/MountedVehiclesTest.scala
+++ b/common/src/test/scala/game/objectcreatevehicle/MountedVehiclesTest.scala
@@ -62,7 +62,7 @@ class MountedVehiclesTest extends Specification {
                         a.data.v5.isEmpty mustEqual true
                         a.exosuit mustEqual ExoSuitType.Agile
                         a.unk5 mustEqual 0
-                        a.unk6 mustEqual 30777081L
+                        a.char_id mustEqual 30777081L
                         a.unk7 mustEqual 1
                         a.unk8 mustEqual 4
                         a.unk9 mustEqual 0
diff --git a/common/src/test/scala/objects/AvatarTest.scala b/common/src/test/scala/objects/AvatarTest.scala
index c2c482c0..33b53ce7 100644
--- a/common/src/test/scala/objects/AvatarTest.scala
+++ b/common/src/test/scala/objects/AvatarTest.scala
@@ -281,7 +281,7 @@ class AvatarTest extends Specification {
 
   "does not have any loadout specifications by default" in {
     val (_, avatar) = CreatePlayer()
-    (0 to 9).foreach { avatar.LoadLoadout(_) mustEqual None }
+    (0 to 9).foreach { avatar.EquipmentLoadouts.LoadLoadout(_) mustEqual None }
     ok
   }
 
@@ -289,9 +289,9 @@ class AvatarTest extends Specification {
     val (obj, avatar) = CreatePlayer()
     obj.Slot(0).Equipment.get.asInstanceOf[Tool].Magazine = 1 //non-standard but legal
     obj.Slot(2).Equipment.get.asInstanceOf[Tool].AmmoSlot.Magazine = 100 //non-standard (and out of range, real=25)
-    avatar.SaveLoadout(obj, "test", 0)
+    avatar.EquipmentLoadouts.SaveLoadout(obj, "test", 0)
 
-    avatar.LoadLoadout(0) match {
+    avatar.EquipmentLoadouts.LoadLoadout(0) match {
       case Some(items : InfantryLoadout) =>
         items.label mustEqual "test"
         items.exosuit mustEqual obj.ExoSuit
@@ -329,25 +329,25 @@ class AvatarTest extends Specification {
 
   "save player's current inventory as a loadout, only found in the called-out slot number" in {
     val (obj, avatar) = CreatePlayer()
-    avatar.SaveLoadout(obj, "test", 0)
+    avatar.EquipmentLoadouts.SaveLoadout(obj, "test", 0)
 
-    avatar.LoadLoadout(1).isDefined mustEqual false
-    avatar.LoadLoadout(0).isDefined mustEqual true
+    avatar.EquipmentLoadouts.LoadLoadout(1).isDefined mustEqual false
+    avatar.EquipmentLoadouts.LoadLoadout(0).isDefined mustEqual true
   }
 
   "try to save player's current inventory as a loadout, but will not save to an invalid slot" in {
     val (obj, avatar) = CreatePlayer()
-    avatar.SaveLoadout(obj, "test", 10)
+    avatar.EquipmentLoadouts.SaveLoadout(obj, "test", 10)
 
-    avatar.LoadLoadout(10) mustEqual None
+    avatar.EquipmentLoadouts.LoadLoadout(10) mustEqual None
   }
 
   "save player's current inventory as a loadout, without inventory contents" in {
     val (obj, avatar) = CreatePlayer()
     obj.Inventory.Clear()
-    avatar.SaveLoadout(obj, "test", 0)
+    avatar.EquipmentLoadouts.SaveLoadout(obj, "test", 0)
 
-    avatar.LoadLoadout(0) match {
+    avatar.EquipmentLoadouts.LoadLoadout(0) match {
       case Some(items : InfantryLoadout) =>
         items.label mustEqual "test"
         items.exosuit mustEqual obj.ExoSuit
@@ -364,9 +364,9 @@ class AvatarTest extends Specification {
     obj.Slot(0).Equipment = None
     obj.Slot(2).Equipment = None
     obj.Slot(4).Equipment = None
-    avatar.SaveLoadout(obj, "test", 0)
+    avatar.EquipmentLoadouts.SaveLoadout(obj, "test", 0)
 
-    avatar.LoadLoadout(0) match {
+    avatar.EquipmentLoadouts.LoadLoadout(0) match {
       case Some(items : InfantryLoadout) =>
         items.label mustEqual "test"
         items.exosuit mustEqual obj.ExoSuit
@@ -380,11 +380,11 @@ class AvatarTest extends Specification {
 
   "save, load, delete; rapidly" in {
     val (obj, avatar) = CreatePlayer()
-    avatar.SaveLoadout(obj, "test", 0)
+    avatar.EquipmentLoadouts.SaveLoadout(obj, "test", 0)
 
-    avatar.LoadLoadout(0).isDefined mustEqual true
-    avatar.DeleteLoadout(0)
-    avatar.LoadLoadout(0) mustEqual None
+    avatar.EquipmentLoadouts.LoadLoadout(0).isDefined mustEqual true
+    avatar.EquipmentLoadouts.DeleteLoadout(0)
+    avatar.EquipmentLoadouts.LoadLoadout(0) mustEqual None
   }
 
   "the fifth slot is the locker wrapped in an EquipmentSlot" in {
diff --git a/common/src/test/scala/objects/terminal/OrderTerminalTest.scala b/common/src/test/scala/objects/terminal/OrderTerminalTest.scala
index 34b21670..c60e1c17 100644
--- a/common/src/test/scala/objects/terminal/OrderTerminalTest.scala
+++ b/common/src/test/scala/objects/terminal/OrderTerminalTest.scala
@@ -87,7 +87,7 @@ class OrderTerminalTest extends Specification {
       player.ExoSuit = ExoSuitType.Agile
       player.Slot(0).Equipment = Tool(GlobalDefinitions.beamer)
       player.Slot(6).Equipment = Tool(GlobalDefinitions.beamer)
-      avatar.SaveLoadout(player, "test", 0)
+      avatar.EquipmentLoadouts.SaveLoadout(player, "test", 0)
 
       val msg = infantryTerminal.Request(player, ItemTransactionMessage(PlanetSideGUID(10), TransactionType.Loadout, 4, "", 0, PlanetSideGUID(0)))
       msg.isInstanceOf[Terminal.InfantryLoadout] mustEqual true
@@ -137,7 +137,7 @@ class OrderTerminalTest extends Specification {
     "player can retrieve a vehicle loadout" in {
       val fury = Vehicle(GlobalDefinitions.fury)
       fury.Slot(30).Equipment = AmmoBox(GlobalDefinitions.hellfire_ammo)
-      avatar.SaveLoadout(fury, "test", 10)
+      avatar.EquipmentLoadouts.SaveLoadout(fury, "test", 10)
 
       val msg = ItemTransactionMessage(PlanetSideGUID(1), TransactionType.Loadout, 4, "test", 0, PlanetSideGUID(0))
       terminal.Request(player, msg) match {
